/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : DigitalIO_platformservice.h
   Author             : Zaid
   Version            : V0.0.0.1
   Origination Date   : 28/01/2022
   Description        : Header File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the DigitalIO platform service declarations

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             28/01/2022           Zaid

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/
#ifndef _DIGITALIO_PLATFORM_SERVICE_H_
#define	_DIGITALIO_PLATFORM_SERVICE_H_

/*!
 * DIO TX RX Q size for
 * receiving and sending data from SDK API.
 */
#define DIO_RX_TX_MAX_Q_SIZE     		10

/*!
 * LOW side driver configuration
 */
#define   CONF_LOW_SIDE_DRIVER        	00

/*!
 * HIGH side driver configuration
 */
#define   CONF_HIGH_SIDE_DRIVER       	01

/*!
 * Open driver configuration
 */
#define   CONF_OPEN_DRIVE_DRIVER      	02

/*!
 * Configure the Digital Output ON
 */
#define   CONF_DIGITAL_OUTPUT_ON		01

/*!
 * Configure the Digital Output OFF
 */
#define   CONF_DIGITAL_OUTPUT_OFF		00

/* Thread State */
#define DIO_THREAD_STATE_RUN   			0
#define DIO_THREAD_STATE_STOP  			1

/*!
 * DIO SDK Field Index
 */
#define DIO_FUNC_INDEX       	      	0
#define DIO_RESULT_INDEX             	0
#define DIO_SUB_FUNC_INDEX				1
#define DIO_STATE_INDEX             	2

/*!
 * Return Error value
 */
#define   VALID_EE_DATA       			1

/*!
 * Function declaration
 */
int8_t DIO_DB_Init(void);

/*!
 * Digital output SDK Message
 */
typedef enum __DO_MSG
{
	DO_SET,
	DO_GET,
}DO_MSG;

/*!
 * Digital output Events
 */
typedef enum __DIO_Event
{
	DIO_MSG_EVENT,
	DIO_CAM_STOP_EVENT,
	DIO_CAM_START_EVENT
}DIO_Event;

/*!
 * DIO Input Function
 */
typedef enum __DIO_Func
{
	SET_DIO_STATE,
	SET_DIO_CFG,
}DIO_Func;

#endif	//_DIGITALIO_PLATFORM_SERVICE_H_

/**************** (C) COPYRIGHT 2022 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
