/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : LightSensor_platformservice.h
   Author             : Rajesh
   Version            : V0.0.0.1
   Origination Date   : 28/01/2022
   Description        : Header File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the Light Sensor platform service declarations

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             28/01/2022           Rajesh

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/
#ifndef _LIGHTSENSOR_PLATFORM_SERVICE_H_
#define	_LIGHTSENSOR_PLATFORM_SERVICE_H_


/*!
 * Function declaration
 */
int8_t LS_DB_Init(void);

/*!
 * Light Sensor Funcationality
 */
typedef enum __LS_Func
{
	LS_FUNC
}LS_Func;

/*!
 * Light Sensor SDK Message
 */
typedef enum __LS_MSG
{
	LS_SET,
	LS_GET,
	LS_ACT,
	LS_GET_CONVERSION_TIME,
	LS_GET_MODE,
	LS_SET_CONVERSION_TIME,
	LS_SET_MODE,
	LS_READ_DATA,
}LS_MSG;

/*!
 * Light Sensor Events
 */
typedef enum __LS_Event
{
	LS_TMR_EVENT,
	LS_MSG_EVENT,
	LS_CAM_STOP_EVENT,
	LS_CAM_START_EVENT
}LS_Event;

/* Thread State */
#define LS_THREAD_STATE_RUN   	  0
#define LS_THREAD_STATE_STOP  	  1

/*!
 * Light Sensor Platform service Task timeout value
 */
#define PS_LS_RAWREAD_TIMER       100

/*!
 * Light Sensor TX Q size for
 * receiving data from SDK API.
 */
#define LS_RX_TX_MAX_Q_SIZE       10

/*!
 * Light Sensor Min and Max Conversion time
 */
#define LS_CONVERSION_TIME_100    0
#define LS_CONVERSION_TIME_800    1

/*!
 * Light Sensor Mode Configuration
 */
#define LS_SHUTDOWN               00
#define LS_SINGLE_MODE_CONV       01
#define LS_CONTINUOUS_MODE_CONV   02

/*!
 * Light Sensor Manufacture ID
 */
#define LS_MANUFACTURE_ID         0x5449

/* !
 * Light Sensor SDK Field Index
 */
#define LS_FUNC_INDEX             	0
#define LS_RESULT_INDEX           	0
#define LS_SUB_FUNC_INDEX           1
#define LS_SUB_FUNC_VAL_INDEX       2

#endif	//_LIGHTSENSOR_PLATFORM_SERVICE_H_

/**************** (C) COPYRIGHT 2022 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
