/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : EE_PH_DB.h
   Author             :	Rajesh
   Version            : V0.0.0.1
   Origination Date   : 04/03/2022
   Description        : Header File.
   Environment        : Independant
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description: EEPROM Place Holder

		General File Description
-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             04/03/2022			Rajesh

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/
#ifndef _EE_PH_DB_H_
#define	_EE_PH_DB_H_
/* Includes ---------------------------------------------------------------*/

/* USER CODE BEGIN enum */
/*!
 * DB Fields
 */
typedef enum __EE_Element
{
    EE_USER_START,
    EE_CAL01,
	EE_CAL02,
	EE_CAL03,
	EE_CAL04,

#if 0
	EE_CAL05,
	EE_CAL06,
	EE_CAL07,
	EE_CAL08,
	EE_CAL09,
	EE_CAL10,
	EE_CAL11,
	EE_CAL12,
	EE_CAL13,
	EE_CAL14,
	EE_CAL15,
	EE_CAL16,
	EE_CAL17,
	EE_CAL18,
	EE_CAL19,
	EE_CAL20,
	EE_CAL21,
	EE_CAL22,
	EE_CAL23,
	EE_CAL24,
	EE_CAL25,
	EE_CAL26,
	EE_CAL27,
	EE_CAL28,
	EE_CAL29,
	EE_CAL30,
	EE_CAL31,
	EE_CAL32,
	EE_CAL33,
	EE_CAL34,
	EE_CAL35,
	EE_CAL36,
	EE_CAL37,
	EE_CAL38,
	EE_CAL39,
	EE_CAL40,
	EE_CAL41,
	EE_CAL42,
	EE_CAL43,
	EE_CAL44,
	EE_CAL45,
	EE_CAL46,
	EE_CAL47,
	EE_CAL48,
	EE_CAL49,
	EE_CAL50,
	EE_CAL51,
	EE_CAL52,
	EE_CAL53,
	EE_CAL54,
	EE_CAL55,
	EE_CAL56,
	EE_CAL57,
	EE_CAL58,
	EE_CAL59,
	EE_CAL60,
	EE_CAL61,
	EE_CAL62,
	EE_CAL63,
	EE_CAL64,
	EE_CAL65,
	EE_CAL66,
	EE_CAL67,
	EE_CAL68,
	EE_CAL69,
	EE_CAL70,
	EE_CAL71,
	EE_CAL72,
	EE_CAL73,
	EE_CAL74,
	EE_CAL75,
	EE_CAL76,
	EE_CAL77,
	EE_CAL78,
	EE_CAL79,
	EE_CAL80,
	EE_CAL81,
	EE_CAL82,
	EE_CAL83,
	EE_CAL84,
	EE_CAL85,
	EE_CAL86,
	EE_CAL87,
	EE_CAL88,
	EE_CAL89,
	EE_CAL90,
	EE_CAL91,
	EE_CAL92,
	EE_CAL93,
	EE_CAL94,
	EE_CAL95,
	EE_CAL96,
	EE_CAL97,
	EE_CAL98,
	EE_CAL99,
	EE_CAL100,
	EE_CAL101,
	EE_CAL102,
	EE_CAL103,
	EE_CAL104,
	EE_CAL105,
	EE_CAL106,
	EE_CAL107,
	EE_CAL108,
	EE_CAL109,
	EE_CAL110,
	EE_CAL111,
	EE_CAL112,
	EE_CAL113,
	EE_CAL114,
	EE_CAL115,
	EE_CAL116,
	EE_CAL117,
	EE_CAL118,
	EE_CAL119,
	EE_CAL120,
	EE_CAL121,
	EE_CAL122,
	EE_CAL123,
	EE_CAL124,
	EE_CAL125,
	EE_CAL126,
	EE_CAL127,
	EE_CAL128,
	EE_CAL129,
	EE_CAL130,
	EE_CAL131,
	EE_CAL132,
	EE_CAL133,
	EE_CAL134,
	EE_CAL135,
	EE_CAL136,
	EE_CAL137,
	EE_CAL138,
	EE_CAL139,
	EE_CAL140,
	EE_CAL141,
	EE_CAL142,
	EE_CAL143,
	EE_CAL144,
	EE_CAL145,
	EE_CAL146,
	EE_CAL147,
	EE_CAL148,
	EE_CAL149,
	EE_CAL150,
	EE_CAL151,
	EE_CAL152,
	EE_CAL153,
	EE_CAL154,
	EE_CAL155,
	EE_CAL156,
	EE_CAL157,
	EE_CAL158,
	EE_CAL159,
	EE_CAL160,
	EE_CAL161,
	EE_CAL162,
	EE_CAL163,
	EE_CAL164,
	EE_CAL165,
	EE_CAL166,
	EE_CAL167,
	EE_CAL168,
	EE_CAL169,
	EE_CAL170,
	EE_CAL171,
	EE_CAL172,
	EE_CAL173,
	EE_CAL174,
	EE_CAL175,
	EE_CAL176,
	EE_CAL177,
	EE_CAL178,
	EE_CAL179,
	EE_CAL180,
	EE_CAL181,
	EE_CAL182,
	EE_CAL183,
	EE_CAL184,
	EE_CAL185,
	EE_CAL186,
	EE_CAL187,
	EE_CAL188,
	EE_CAL189,
	EE_CAL190,
	EE_CAL191,
	EE_CAL192,
	EE_CAL193,
	EE_CAL194,
	EE_CAL195,
	EE_CAL196,
	EE_CAL197,
	EE_CAL198,
	EE_CAL199,
	EE_CAL200,
	EE_CAL201,
	EE_CAL202,
	EE_CAL203,
	EE_CAL204,
	EE_CAL205,
	EE_CAL206,
	EE_CAL207,
	EE_CAL208,
	EE_CAL209,
	EE_CAL210,
	EE_CAL211,
	EE_CAL212,
	EE_CAL213,
	EE_CAL214,
	EE_CAL215,
	EE_CAL216,
	EE_CAL217,
	EE_CAL218,
	EE_CAL219,
	EE_CAL220,
	EE_CAL221,
	EE_CAL222,
	EE_CAL223,
	EE_CAL224,
	EE_CAL225,
	EE_CAL226,
	EE_CAL227,
	EE_CAL228,
	EE_CAL229,
	EE_CAL230,
	EE_CAL231,
	EE_CAL232,
	EE_CAL233,
	EE_CAL234,
	EE_CAL235,
	EE_CAL236,
	EE_CAL237,
	EE_CAL238,
	EE_CAL239,
	EE_CAL240,
	EE_CAL241,
	EE_CAL242,
	EE_CAL243,
	EE_CAL244,
	EE_CAL245,
	EE_CAL246,
	EE_CAL247,
	EE_CAL248,
	EE_CAL249,
	EE_CAL250,
	EE_CAL251,
	EE_CAL252,
	EE_CAL253,
	EE_CAL254,
	EE_CAL255,
	EE_CAL256,
	EE_CAL257,
	EE_CAL258,
	EE_CAL259,
	EE_CAL260,
	EE_CAL261,
	EE_CAL262,
	EE_CAL263,
	EE_CAL264,
	EE_CAL265,
	EE_CAL266,
	EE_CAL267,
	EE_CAL268,
	EE_CAL269,
	EE_CAL270,
	EE_CAL271,
	EE_CAL272,
	EE_CAL273,
	EE_CAL274,
	EE_CAL275,
	EE_CAL276,
	EE_CAL277,
	EE_CAL278,
	EE_CAL279,
	EE_CAL280,
	EE_CAL281,
	EE_CAL282,
	EE_CAL283,
	EE_CAL284,
	EE_CAL285,
	EE_CAL286,
	EE_CAL287,
	EE_CAL288,
	EE_CAL289,
	EE_CAL290,
	EE_CAL291,
	EE_CAL292,
	EE_CAL293,
	EE_CAL294,
	EE_CAL295,
	EE_CAL296,
	EE_CAL297,
	EE_CAL298,
	EE_CAL299,
	EE_CAL300,
#endif

    EE_USER_END,
}EE_Element;


#endif	//_EE_PH_DB_H_
/**************** (C) COPYRIGHT 2022 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
