/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : Input_Frequency.h
   Author             : Zaid
   Version            : V0.0.0.1
   Origination Date   : 04/02/2022
   Description        : Header File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the Input Frequency configuration structures and macros

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             04/02/2022           Zaid
   0.0.0.2             10/04/2022           FOC Corrected Period, and monitoring 0Hz input values

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/
#ifndef _INPUT_FREQUENCY_H_
#define	_INPUT_FREQUENCY_H_

#define PERIOD_TIM_2		65535
#define PERIOD_TIM_3		65535
#define PERIOD_TIM_14		65535
#define PERIOD_TIM_13		65535

// number of overflows for Frequency input timeout
#define FQ_DOG_LIMIT        500

/*!
 * Function Declaration
 */
void FreqAI_Start(int idx);
//CIN1
uint8_t FI_Chk_CIN1_Frequency(void);
void FI_Mon_CIN1_Frequency(void);
void FI_Set_CIN1_Frequency(uint32_t value);
//CIN2
uint8_t FI_Chk_CIN2_Frequency(void);
void FI_Mon_CIN2_Frequency(void);
void FI_Set_CIN2_Frequency(uint32_t value);
//CIN3
uint8_t FI_Chk_CIN3_Frequency(void);
void FI_Mon_CIN3_Frequency(void);
void FI_Set_CIN3_Frequency(uint32_t value);
//CIN4
uint8_t FI_Chk_CIN4_Frequency(void);
void FI_Mon_CIN4_Frequency(void);
void FI_Set_CIN4_Frequency(uint32_t value);
//CIN5
uint8_t FI_Chk_CIN5_Frequency(void);
void FI_Mon_CIN5_Frequency(void);
void FI_Set_CIN5_Frequency(uint32_t value);
//CIN6
uint8_t FI_Chk_CIN6_Frequency(void);
void FI_Mon_CIN6_Frequency(void);
void FI_Set_CIN6_Frequency(uint32_t value);
//
void FI_Set_VhConfig(uint8_t value);

#endif	//_INPUT_FREQUENCY_H_
