/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : Configurableinput.c
   Author             : Zaid
   Version            : V0.0.0.1
   Origination Date   : 04/02/2022
   Description        : C Source File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the Configuration Input HAL driver functions

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             04/02/2022           Zaid

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/

/* USER CODE BEGIN Includes */
#include "../../../Core/Maximatecc/Inc/Common.h"
#include "../../Drivers/Maximatecc/inc/IO_Expander_TCA9535.h"
#include "../../Drivers/Maximatecc/inc/input_control.h"
#include "../Inc/ConfigurableInput.h"
#include "../../../Core/Maximatecc/Inc/Frequency_Timer_Init.h"
/* USER CODE END Includes */
uint8_t ci_frequency_1 = 0;
uint8_t ci_frequency_2 = 0;
uint8_t ci_frequency_3 = 0;
uint8_t ci_frequency_4 = 0;
uint8_t ci_frequency_5 = 0;

/** @brief CI Initialize
 *
 *  This function initializes the DIO Expander
 *  IO pins.
 *
 *  @param  None
 *
 *
 *  @return 0 : PS_SUCCESS
 *          1 : PS_FAILURE
 */
int8_t CI_Init(I2C_HandleTypeDef *hi2c)
{
	HAL_StatusTypeDef ret;
	TCA9535Regs Regs;

	/* Get the IO Expander Semaphore */
	TakeIOExpanderLock();

	/* Read the Config reg from the IO Expander */
	ret = TCA9535ReadConfig(hi2c, &Regs, TCA9535_ADDRESS);
	HAL_Delay(50);

	if(HAL_ERROR == ret)
		return PS_FAILURE;

	/* Make the DIO Pins as output */
   	Regs.Config.Port.P0.bit.B0 = 0;
   	Regs.Config.Port.P0.bit.B1 = 0;
   	Regs.Config.Port.P0.bit.B2 = 0;
   	Regs.Config.Port.P0.bit.B3 = 0;
   	Regs.Config.Port.P0.bit.B4 = 0;
   	Regs.Config.Port.P0.bit.B5 = 0;
   	Regs.Config.Port.P1.bit.B0 = 0;
   	Regs.Config.Port.P1.bit.B1 = 0;
   	Regs.Config.Port.P1.bit.B2 = 0;
   	Regs.Config.Port.P1.bit.B3 = 0;
   	Regs.Config.Port.P1.bit.B4 = 0;
   	Regs.Config.Port.P1.bit.B5 = 0;

	/* Set the DIO IO pins status into the IO Expander */
	ret = TCA9535WriteConfig(hi2c, &Regs, TCA9535_ADDRESS);
	HAL_Delay(50);

	/* Read the Polarity Reg from the IO Expander */
	ret = TCA9535ReadPolarity(hi2c, &Regs, TCA9535_ADDRESS);
	HAL_Delay(50);

	if(HAL_ERROR == ret)
		return PS_FAILURE;

	/* Change the Polarity Register */
   	Regs.Config.Port.P0.bit.B0 = 0;
   	Regs.Config.Port.P0.bit.B1 = 0;
   	Regs.Config.Port.P0.bit.B2 = 0;
   	Regs.Config.Port.P0.bit.B3 = 0;
   	Regs.Config.Port.P0.bit.B4 = 0;
   	Regs.Config.Port.P0.bit.B5 = 0;
   	Regs.Config.Port.P1.bit.B0 = 0;
   	Regs.Config.Port.P1.bit.B1 = 0;
   	Regs.Config.Port.P1.bit.B2 = 0;
   	Regs.Config.Port.P1.bit.B3 = 0;
   	Regs.Config.Port.P1.bit.B4 = 0;
   	Regs.Config.Port.P1.bit.B5 = 0;
	/* Set the DIO IO pins Polarity into the IO Expander */
	ret = TCA9535WritePolarity(hi2c, &Regs, TCA9535_ADDRESS);
	HAL_Delay(50);

	/* Read the Config reg from the IO Expander */
	ret = TCA9535ReadConfig(hi2c, &Regs, TCA9535_2_ADDRESS);
	HAL_Delay(50);

	if(HAL_ERROR == ret)
		return PS_FAILURE;

	/* Make the DIO Pins as output */
   	Regs.Config.Port.P0.bit.B0 = 0;
   	Regs.Config.Port.P0.bit.B1 = 0;
   	Regs.Config.Port.P0.bit.B2 = 0;
   	Regs.Config.Port.P0.bit.B3 = 0;
   	Regs.Config.Port.P0.bit.B4 = 0;
   	Regs.Config.Port.P0.bit.B5 = 0;
   	Regs.Config.Port.P1.bit.B0 = 0;
   	Regs.Config.Port.P1.bit.B1 = 0;
   	Regs.Config.Port.P1.bit.B2 = 0;
   	Regs.Config.Port.P1.bit.B3 = 0;
   	Regs.Config.Port.P1.bit.B4 = 0;
   	Regs.Config.Port.P1.bit.B5 = 0;

	/* Set the DIO IO pins status into the IO Expander */
	ret = TCA9535WriteConfig(hi2c, &Regs, TCA9535_2_ADDRESS);
	HAL_Delay(50);

	/* Read the Polarity Reg from the IO Expander */
	ret = TCA9535ReadPolarity(hi2c, &Regs, TCA9535_2_ADDRESS);
	HAL_Delay(50);

	if(HAL_ERROR == ret)
		return PS_FAILURE;

	/* Change the Polarity Register */
   	Regs.Config.Port.P0.bit.B0 = 0;
   	Regs.Config.Port.P0.bit.B1 = 0;
   	Regs.Config.Port.P0.bit.B2 = 0;
   	Regs.Config.Port.P0.bit.B3 = 0;
   	Regs.Config.Port.P0.bit.B4 = 0;
   	Regs.Config.Port.P0.bit.B5 = 0;
   	Regs.Config.Port.P1.bit.B0 = 0;
   	Regs.Config.Port.P1.bit.B1 = 0;
   	Regs.Config.Port.P1.bit.B2 = 0;
   	Regs.Config.Port.P1.bit.B3 = 0;
   	Regs.Config.Port.P1.bit.B4 = 0;
   	Regs.Config.Port.P1.bit.B5 = 0;
	/* Set the DIO IO pins Polarity into the IO Expander */
	ret = TCA9535WritePolarity(hi2c, &Regs, TCA9535_2_ADDRESS);
	HAL_Delay(50);

	/* Release the Semaphore */
	GiveIOExpanderLock();

	return PS_SUCCESS;
}

/** @brief Analog Input configuration
 *
 *  This function sets the Configuration Input configuration
 *  in the IO Expander Pins for the AI.
 *
 *  @param  None
 *
 *  @return 0 : PS_SUCCESS
 *          1 : PS_FAILURE
 */
int8_t CI_AI1(I2C_HandleTypeDef *hi2c, uint8_t type)
{
	HAL_StatusTypeDef ret;
	TCA9535Regs Regs;
	GPIO_InitTypeDef GPIO_InitStruct = {0};

	/* Get the IO Expander Semaphore */
	TakeI2CBusLock();
	/* Read the Output Pin from the IO Expander */
	ret = TCA9535ReadOutput(hi2c, &Regs, TCA9535_ADDRESS);
	HAL_Delay(20);
	if(HAL_ERROR == ret)
		return PS_FAILURE;

	switch(type)
	{
	    case INPUT_FREQUENCY:
			/* CIN_VR_EN1 Pin */
			Regs.Output.Port.P0.bit.B0 = 1;
			/* CIN_PDA1 */
			Regs.Output.Port.P0.bit.B1 = 0;
			/* CIN_PDB1 */
			Regs.Output.Port.P0.bit.B2 = 0;
			ci_frequency_1 = INPUT_FREQUENCY;
			Timer13_Init();

			break;

		case DIGITAL_STB:
		case INPUT_VOLTAGE_HIGH:
			/* CIN_VR_EN1 Pin */
			Regs.Output.Port.P0.bit.B0 = 1;
			/* CIN_PDA1 */
			Regs.Output.Port.P0.bit.B1 = 0;
			/* CIN_PDB1 */
			Regs.Output.Port.P0.bit.B2 = 1;

			HAL_GPIO_DeInit(GPIOF, GPIO_PIN_8);
			GPIO_InitStruct.Pin = GPIO_PIN_8;
			GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
			GPIO_InitStruct.Pull = GPIO_NOPULL;
			HAL_GPIO_Init(GPIOF, &GPIO_InitStruct);

			break;

		case DIGITAL_STG:
		case INPUT_RESISTANCE:
			/* CIN_VR_EN1 Pin */
			Regs.Output.Port.P0.bit.B0 = 0;
			/* CIN_PDA1 */
			Regs.Output.Port.P0.bit.B1 = 0;
			/* CIN_PDB1 */
			Regs.Output.Port.P0.bit.B2 = 0;
			HAL_GPIO_DeInit(GPIOF, GPIO_PIN_8);
			GPIO_InitStruct.Pin = GPIO_PIN_8;
			GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
			GPIO_InitStruct.Pull = GPIO_NOPULL;
			HAL_GPIO_Init(GPIOF, &GPIO_InitStruct);
			break;

		case INPUT_VOLTAGE_LOW_6V:
			/* CIN_VR_EN1 Pin */
			Regs.Output.Port.P0.bit.B0 = 1;
			/* CIN_PDA1 */
			Regs.Output.Port.P0.bit.B1 = 1;
			/* CIN_PDB1 */
			Regs.Output.Port.P0.bit.B2 = 0;
			HAL_GPIO_DeInit(GPIOF, GPIO_PIN_8);
			GPIO_InitStruct.Pin = GPIO_PIN_8;
			GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
			GPIO_InitStruct.Pull = GPIO_NOPULL;
			HAL_GPIO_Init(GPIOF, &GPIO_InitStruct);
			break;

		default:
			break;
	  }

	/* Set the Configuration Input pins configuration into the IO Expander */
    ret = TCA9535WriteOutput(hi2c, &Regs, TCA9535_ADDRESS);
	HAL_Delay(20);
	if(HAL_ERROR == ret)
		return PS_FAILURE;

	/* Release the Semaphore */
	GiveI2CBusLock();

	return PS_SUCCESS;
}


/** @brief Analog Input 2 configuration
 *
 *  This function sets the Configuration Input configuration
 *  in the IO Expander Pins for the AI.
 *
 *  @param  None
 *
 *  @return 0 : PS_SUCCESS
 *          1 : PS_FAILURE
 */
int8_t CI_AI2(I2C_HandleTypeDef *hi2c, uint8_t type)
{
	HAL_StatusTypeDef ret;
	TCA9535Regs Regs;
	GPIO_InitTypeDef GPIO_InitStruct = {0};
	/* Get the IO Expander Semaphore */
	TakeI2CBusLock();

	/* Read the Output Pin from the IO Expander */
	ret = TCA9535ReadOutput(hi2c, &Regs, TCA9535_2_ADDRESS);
	HAL_Delay(20);
	if(HAL_ERROR == ret)
		return PS_FAILURE;

	switch(type)
	{
	    case INPUT_FREQUENCY:
			/* CIN_VR_EN2 Pin */
			Regs.Output.Port.P0.bit.B5 = 1;
			/* CIN_PDB2 */
			Regs.Output.Port.P0.bit.B6 = 0;
			/* CIN_PDA2 */
			Regs.Output.Port.P0.bit.B7 = 0;
			ci_frequency_2 = INPUT_FREQUENCY;
			Timer14_Init();
			break;

		case DIGITAL_STB:
		case INPUT_VOLTAGE_HIGH:
			/* CIN_VR_EN2 Pin */
			Regs.Output.Port.P0.bit.B5 = 1;
			/* CIN_PDB2 */
			Regs.Output.Port.P0.bit.B6 = 1;
			/* CIN_PDA2 */
			Regs.Output.Port.P0.bit.B7 = 0;
			HAL_GPIO_DeInit(GPIOF, GPIO_PIN_9);
			GPIO_InitStruct.Pin = GPIO_PIN_9;
			GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
			GPIO_InitStruct.Pull = GPIO_NOPULL;
			HAL_GPIO_Init(GPIOF, &GPIO_InitStruct);
			break;

		case DIGITAL_STG:
		case INPUT_RESISTANCE:
			/* CIN_VR_EN2 Pin */
			Regs.Output.Port.P0.bit.B5 = 0;
			/* CIN_PDB2 */
			Regs.Output.Port.P0.bit.B6 = 0;
			/* CIN_PDA2 */
			Regs.Output.Port.P0.bit.B7 = 0;
			HAL_GPIO_DeInit(GPIOF, GPIO_PIN_9);
			GPIO_InitStruct.Pin = GPIO_PIN_9;
			GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
			GPIO_InitStruct.Pull = GPIO_NOPULL;
			HAL_GPIO_Init(GPIOF, &GPIO_InitStruct);
			break;

		case INPUT_VOLTAGE_LOW_6V:
			/* CIN_VR_EN2 Pin */
			Regs.Output.Port.P0.bit.B5 = 1;
			/* CIN_PDB2 */
			Regs.Output.Port.P0.bit.B6 = 0;
			/* CIN_PDA2 */
			Regs.Output.Port.P0.bit.B7 = 1;
			HAL_GPIO_DeInit(GPIOF, GPIO_PIN_9);
			GPIO_InitStruct.Pin = GPIO_PIN_9;
			GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
			GPIO_InitStruct.Pull = GPIO_NOPULL;
			HAL_GPIO_Init(GPIOF, &GPIO_InitStruct);
			break;

		default:
			break;
	  }

	/* Set the configuration Input pins configuration into the IO Expander */
    ret = TCA9535WriteOutput(hi2c, &Regs, TCA9535_2_ADDRESS);
	HAL_Delay(20);
	if(HAL_ERROR == ret)
		return PS_FAILURE;

	/* Release the Semaphore */
	GiveI2CBusLock();

	return PS_SUCCESS;
}

/** @brief Analog Input 3 configuration
 *
 *  This function sets the Configuration Input configuration
 *  in the IO Expander Pins for the AI.
 *
 *  @param  None
 *
 *  @return 0 : PS_SUCCESS
 *          1 : PS_FAILURE
 */
int8_t CI_AI3(I2C_HandleTypeDef *hi2c, uint8_t type)
{
	HAL_StatusTypeDef ret;
	TCA9535Regs Regs;
	GPIO_InitTypeDef GPIO_InitStruct = {0};
	/* Get the IO Expander Semaphore */
	TakeI2CBusLock();

	/* Read the Output Pin from the IO Expander */
	ret = TCA9535ReadOutput(hi2c, &Regs, TCA9535_2_ADDRESS);
	HAL_Delay(20);
	if(HAL_ERROR == ret)
		return PS_FAILURE;

	switch(type)
	{
	    case INPUT_FREQUENCY:
			/* CIN_VR_EN3 Pin */
			Regs.Output.Port.P1.bit.B0 = 1;
			/* CIN_PDB3 */
			Regs.Output.Port.P1.bit.B1 = 0;
			/* CIN_PDA3 */
			Regs.Output.Port.P1.bit.B2 = 0;
			ci_frequency_3 = INPUT_FREQUENCY;
			Timer2_Init();
			break;

		case DIGITAL_STB:
		case INPUT_VOLTAGE_HIGH:
			/* CIN_VR_EN3 Pin */
			Regs.Output.Port.P1.bit.B0 = 1;
			/* CIN_PDB3 */
			Regs.Output.Port.P1.bit.B1 = 1;
			/* CIN_PDA3 */
			Regs.Output.Port.P1.bit.B2 = 0;
			HAL_GPIO_DeInit(GPIOA, GPIO_PIN_1);
			GPIO_InitStruct.Pin = GPIO_PIN_1;
			GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
			GPIO_InitStruct.Pull = GPIO_NOPULL;
			HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);
			break;

		case DIGITAL_STG:
		case INPUT_RESISTANCE:
			/* CIN_VR_EN3 Pin */
			Regs.Output.Port.P1.bit.B0 = 0;
			/* CIN_PDB3 */
			Regs.Output.Port.P1.bit.B1 = 0;
			/* CIN_PDA3 */
			Regs.Output.Port.P1.bit.B2 = 0;
			HAL_GPIO_DeInit(GPIOA, GPIO_PIN_1);
			GPIO_InitStruct.Pin = GPIO_PIN_1;
			GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
			GPIO_InitStruct.Pull = GPIO_NOPULL;
			HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);
			break;

		case INPUT_VOLTAGE_LOW_6V:
			/* CIN_VR_EN3 Pin */
			Regs.Output.Port.P1.bit.B0 = 1;
			/* CIN_PDB3 */
			Regs.Output.Port.P1.bit.B1 = 0;
			/* CIN_PDA3 */
			Regs.Output.Port.P1.bit.B2 = 1;
			HAL_GPIO_DeInit(GPIOA, GPIO_PIN_1);
			GPIO_InitStruct.Pin = GPIO_PIN_1;
			GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
			GPIO_InitStruct.Pull = GPIO_NOPULL;
			HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);
			break;

		default:
			break;
	  }

	/* Set the configuration Input pins configuration into the IO Expander */
    ret = TCA9535WriteOutput(hi2c, &Regs, TCA9535_2_ADDRESS);
	HAL_Delay(20);
	if(HAL_ERROR == ret)
		return PS_FAILURE;

	/* Release the Semaphore */
	GiveI2CBusLock();

	return PS_SUCCESS;
}

/** @brief Analog Input 4 configuration
 *
 *  This function sets the Configuration Input configuration
 *  in the IO Expander Pins for the AI.
 *
 *  @param  None
 *
 *  @return 0 : PS_SUCCESS
 *          1 : PS_FAILURE
 */
int8_t CI_AI4(I2C_HandleTypeDef *hi2c, uint8_t type)
{
	HAL_StatusTypeDef ret;
	TCA9535Regs Regs;
	GPIO_InitTypeDef GPIO_InitStruct = {0};
	/* Get the IO Expander Semaphore */
	TakeI2CBusLock();

	/* Read the Output Pin from the IO Expander */
	ret = TCA9535ReadOutput(hi2c, &Regs, TCA9535_ADDRESS);
	HAL_Delay(20);
	if(HAL_ERROR == ret)
		return PS_FAILURE;

	switch(type)
	{
	    case INPUT_FREQUENCY:
			/* CIN_VR_EN4 Pin */
			Regs.Output.Port.P1.bit.B5 = 1;
			/* CIN_PDA4 */
			Regs.Output.Port.P1.bit.B4 = 0;
			/* CIN_PDB4 */
			Regs.Output.Port.P1.bit.B3 = 0;
			ci_frequency_4 = INPUT_FREQUENCY;
			Timer2_Init();
			break;

		case DIGITAL_STB:
		case INPUT_VOLTAGE_HIGH:
			/* CIN_VR_EN4 Pin */
			Regs.Output.Port.P1.bit.B5 = 1;
			/* CIN_PDA4 */
			Regs.Output.Port.P1.bit.B4 = 0;
			/* CIN_PDB4 */
			Regs.Output.Port.P1.bit.B3 = 1;
			HAL_GPIO_DeInit(GPIOA, GPIO_PIN_0);
			GPIO_InitStruct.Pin = GPIO_PIN_0;
			GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
			GPIO_InitStruct.Pull = GPIO_NOPULL;
			HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);
			break;

		case DIGITAL_STG:
		case INPUT_RESISTANCE:
			/* CIN_VR_EN4 Pin */
			Regs.Output.Port.P1.bit.B5 = 0;
			/* CIN_PDA4 */
			Regs.Output.Port.P1.bit.B4 = 0;
			/* CIN_PDB4 */
			Regs.Output.Port.P1.bit.B3 = 0;
			HAL_GPIO_DeInit(GPIOA, GPIO_PIN_0);
			GPIO_InitStruct.Pin = GPIO_PIN_0;
			GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
			GPIO_InitStruct.Pull = GPIO_NOPULL;
			HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);
			break;

		case INPUT_VOLTAGE_LOW_6V:
			/* CIN_VR_EN4 Pin */
			Regs.Output.Port.P1.bit.B5 = 1;
			/* CIN_PDA4 */
			Regs.Output.Port.P1.bit.B4 = 1;
			/* CIN_PDB4 */
			Regs.Output.Port.P1.bit.B3 = 0;
			HAL_GPIO_DeInit(GPIOA, GPIO_PIN_0);
			GPIO_InitStruct.Pin = GPIO_PIN_0;
			GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
			GPIO_InitStruct.Pull = GPIO_NOPULL;
			HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);
			break;

		default:
			break;
	  }

	/* Set the configuration Input pins configuration into the IO Expander */
    ret = TCA9535WriteOutput(hi2c, &Regs, TCA9535_ADDRESS);
	HAL_Delay(20);
	if(HAL_ERROR == ret)
		return PS_FAILURE;

	/* Release the Semaphore */
	GiveI2CBusLock();

	return PS_SUCCESS;
}

/** @brief Analog Input 5 configuration
 *
 *  This function sets the Configuration Input configuration
 *  in the IO Expander Pins for the AI.
 *
 *  @param  None
 *
 *  @return 0 : PS_SUCCESS
 *          1 : PS_FAILURE
 */
int8_t CI_AI5(I2C_HandleTypeDef *hi2c, uint8_t type)
{
	HAL_StatusTypeDef ret;
	TCA9535Regs Regs;
	GPIO_InitTypeDef GPIO_InitStruct = {0};
	/* Get the IO Expander Semaphore */
	TakeI2CBusLock();

	/* Read the Output Pin from the IO Expander */
	ret = TCA9535ReadOutput(hi2c, &Regs, TCA9535_ADDRESS);
	HAL_Delay(20);
	if(HAL_ERROR == ret)
		return PS_FAILURE;

	switch(type)
	{
	    case INPUT_FREQUENCY:
			/* CIN_VR_EN5 Pin */
			Regs.Output.Port.P1.bit.B0 = 1;
			/* CIN_PDA5 */
			Regs.Output.Port.P1.bit.B1 = 0;
			/* CIN_PDB5 */
			Regs.Output.Port.P1.bit.B2 = 0;
			ci_frequency_5 = INPUT_FREQUENCY;
			Timer3_Init();
			break;

		case DIGITAL_STB:
		case INPUT_VOLTAGE_HIGH:
			/* CIN_VR_EN5 Pin */
			Regs.Output.Port.P1.bit.B0 = 1;
			/* CIN_PDA5 */
			Regs.Output.Port.P1.bit.B1 = 0;
			/* CIN_PDB5 */
			Regs.Output.Port.P1.bit.B2 = 1;
			HAL_GPIO_DeInit(GPIOA, GPIO_PIN_7);
			GPIO_InitStruct.Pin = GPIO_PIN_7;
			GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
			GPIO_InitStruct.Pull = GPIO_NOPULL;
			HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);
			break;

		case DIGITAL_STG:
		case INPUT_RESISTANCE:
			/* CIN_VR_EN5 Pin */
			Regs.Output.Port.P1.bit.B0 = 0;
			/* CIN_PDA5 */
			Regs.Output.Port.P1.bit.B1 = 0;
			/* CIN_PDB5 */
			Regs.Output.Port.P1.bit.B2 = 0;
			GPIO_InitStruct.Pin = GPIO_PIN_7;
			GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
			GPIO_InitStruct.Pull = GPIO_NOPULL;
			HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);
			break;

		case INPUT_VOLTAGE_LOW_6V:
			/* CIN_VR_EN5 Pin */
			Regs.Output.Port.P1.bit.B0 = 1;
			/* CIN_PDA5 */
			Regs.Output.Port.P1.bit.B1 = 1;
			/* CIN_PDB5 */
			Regs.Output.Port.P1.bit.B2 = 0;
			GPIO_InitStruct.Pin = GPIO_PIN_7;
			GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
			GPIO_InitStruct.Pull = GPIO_NOPULL;
			HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);
			break;

		default:
			break;
	  }

	/* Set the configuration Input pins configuration into the IO Expander */
    ret = TCA9535WriteOutput(hi2c, &Regs, TCA9535_ADDRESS);
	HAL_Delay(20);
	if(HAL_ERROR == ret)
		return PS_FAILURE;

	/* Release the Semaphore */
	GiveI2CBusLock();

	return PS_SUCCESS;
}

/** @brief Analog Input 6 configuration
 *
 *  This function sets the Configuration Input configuration
 *  in the IO Expander Pins for the AI.
 *
 *  @param  None
 *
 *  @return 0 : PS_SUCCESS
 *          1 : PS_FAILURE
 */
int8_t CI_AI6(I2C_HandleTypeDef *hi2c, uint8_t type)
{
	HAL_StatusTypeDef ret;
	TCA9535Regs Regs;

	/* Get the IO Expander Semaphore */
	TakeI2CBusLock();

	/* Read the Output Pin from the IO Expander */
	ret = TCA9535ReadOutput(hi2c, &Regs, TCA9535_ADDRESS);
	HAL_Delay(20);
	if(HAL_ERROR == ret)
		return PS_FAILURE;

	switch(type)
	{
	    case INPUT_FREQUENCY:
			/* CIN_PDB6 Pin */
			Regs.Output.Port.P0.bit.B3 = 0;
			/* CIN_PDA6 */
			Regs.Output.Port.P0.bit.B4 = 0;
			/* CIN_VR_EN6 */
			Regs.Output.Port.P0.bit.B5 = 1;
			break;

		case DIGITAL_STB:
		case INPUT_VOLTAGE_HIGH:
		case DIGITAL_STG:
		case INPUT_RESISTANCE:
			/* CIN_PDB6 Pin */
			Regs.Output.Port.P0.bit.B3 = 0;
			/* CIN_PDA6 */
			Regs.Output.Port.P0.bit.B4 = 0;
			/* CIN_VR_EN6 */
			Regs.Output.Port.P0.bit.B5 = 0;
			break;

		case INPUT_VOLTAGE_LOW_6V:
			/* CIN_PDB6 Pin */
			Regs.Output.Port.P0.bit.B3 = 0;
			/* CIN_PDA6 */
			Regs.Output.Port.P0.bit.B4 = 1;
			/* CIN_VR_EN6 */
			Regs.Output.Port.P0.bit.B5 = 1;
			break;

		case INPUT_CURRENT:
			/* CIN_PDB6 Pin */
			Regs.Output.Port.P0.bit.B3 = 1;
			/* CIN_PDA6 */
			Regs.Output.Port.P0.bit.B4 = 0;
			/* CIN_VR_EN6 */
			Regs.Output.Port.P0.bit.B5 = 1;
			break;

		default:
			break;
	  }

	/* Set the Configuration Input pins configuration into the IO Expander */
    ret = TCA9535WriteOutput(hi2c, &Regs, TCA9535_ADDRESS);
	HAL_Delay(20);
	if(HAL_ERROR == ret)
		return PS_FAILURE;

	/* Release the Semaphore */
	GiveI2CBusLock();

	return PS_SUCCESS;
}

int8_t SetAI(I2C_HandleTypeDef *hi2c, uint8_t ai, INPUT_TYPE type)
{

	switch(ai)
	{
		case CONFIG_AI1://an 1
			CI_AI1(hi2c, type);
			break;
		case CONFIG_AI2://an2
			CI_AI2(hi2c, type);
			break;
		case CONFIG_AI3://an3
			CI_AI3(hi2c, type);
			break;
		case CONFIG_AI4://an4
			CI_AI4(hi2c, type);
			break;
		case CONFIG_AI5://an5
			CI_AI5(hi2c, type);
			break;
		case CONFIG_AI6://an6
			CI_AI6(hi2c, type);
			break;
	}

	return PS_SUCCESS;
}

/**************** (C) COPYRIGHT 2022 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
