/****************************************************************************
Copyright (c) 2012 Maxima Technologies and Systems
All Rights Reserved
File Name : adv7180.c
Author : upender chennoju
Version : V0.0.0.1
Origination Date : 10/15/2019
Description : C Source File. 
Environment : Independant
Processor: : Independant
-----------------------------------------------------------------------------
Description:
This file provides the adv7180 camera driver.
configuration to be loaded into the decoder in order to capture the video from
the NTSC camera source.
-----------------------------------------------------------------------------
File Revision History:
-----------------------------------------------------------------------------
Version Date Programmer
0.0.0.0 04/04/2011 Name Last_Name
Notes: - Initial Version
-----------------------------------------------------------------------------
Version Date Programmer
0.0.0.1 31/03/2011 Name Last_Name
Notes: - Second Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/
/* Includes ---------------------------------------------------------------*/
#include "../inc/adv7180.h"
/* Private typedef --------------------------------------------------------*/
//CAMERA_DrvTypeDef   adv7180_drv =
//{
//  //adv7180_Init,
//  adv7180_ReadID,
//  adv7180_Config,
//};

/* Private define ---------------------------------------------------------*/

/* Private macro ----------------------------------------------------------*/
/* Private variables ------------------------------------------------------*/
volatile uint16_t lock_Counter = 0;
volatile uint16_t lock_Counter1 = 0;
volatile uint16_t lock_Counter2 = 0;
volatile uint16_t lock_Counter3 = 0;
volatile uint8_t detected=0; 
volatile uint16_t sReconnected = 0;
volatile uint16_t sDisconnected = 0;
//static uint8_t begin_check =0;
extern volatile uint8_t is_image_enable;
extern uint8_t is_video_mode;
volatile uint16_t is_image_enabled=0;

/* Private functions declaration ------------------------------------------*/
void config_write_one(uint16_t DeviceAddr);
void config_write_two(uint16_t DeviceAddr);
void config_write_three(uint16_t DeviceAddr);
void config_write_four(uint16_t DeviceAddr);
void config_write_five(uint16_t DeviceAddr);

void config_read_one(uint16_t DeviceAddr);
void config_read_two(uint16_t DeviceAddr);
void config_read_three(uint16_t DeviceAddr);
void config_read_four(uint16_t DeviceAddr);
void config_read_five(uint16_t DeviceAddr);

extern void            IOE_Write(uint8_t Addr, uint8_t Reg, uint8_t Value);
extern uint8_t         IOE_Read(uint8_t Addr, uint8_t Reg);
extern void HAL_Delay(uint32_t Delay);


extern I2C_HandleTypeDef hi2c3;

/****************************************************************************
Function Name: . I2Cx_Error()
Description: . Re-Initializes Camera I2C Peripheral incase of Error.
Parameters: .
Dependencies: .
Assumptions: . .
Limitations: .
Exception: .
Handling: .
****************************************************************************/
static void I2Cx_Error(uint8_t Addr)
{
}
/* PUBLIC functions definition --------------------------------------------*/
/* PRIVATE functions definition -------------------------------------------*/

/****************************************************************************
Function Name: . I2Cx_ReadMultiple()
Description: . To read data from the I2C bus.
Parameters: . Addr : read address
            Reg  : register address
            MemAddress : Size of internal memory address
            Buffer : Buffer to store the received data.
            Length : Length of the buffer to read.
Dependencies: .
Assumptions: . .
Limitations: .
Exception: .
Handling: .
****************************************************************************/
static HAL_StatusTypeDef I2Cx_ReadMultiple(uint8_t Addr, uint16_t Reg,
                                           uint16_t MemAddress, uint8_t *Buffer,
                                           uint16_t Length)
{
  HAL_StatusTypeDef status = HAL_OK;


    status = HAL_I2C_Mem_Read(&hi2c3, Addr, (uint16_t)Reg, MemAddress,
                              Buffer, Length, 1000);

//    status = HAL_I2C_Mem_Read_IT(&hi2c3, (uint16_t)Addr, (uint16_t) Reg,
//                                 MemAddress, Buffer,Length);


  /* Check the communication status */
  if(status != HAL_OK)
  {
    /* I2C error occurred */
    I2Cx_Error(Addr);//just the first time
  }
  return status;
}

/****************************************************************************
Function Name: . I2Cx_WriteMultiple()
Description: . To write data from the I2C bus.
Parameters: . Addr : write address
            Reg  : register address
            MemAddress : Size of internal memory address
            Buffer : Buffer to send on the bus
            Length : Length of the buffer to write.
Dependencies: .
Assumptions: . .
Limitations: .
Exception: .
Handling: .
****************************************************************************/
static HAL_StatusTypeDef I2Cx_WriteMultiple(uint8_t Addr, uint16_t Reg,
                                            uint16_t MemAddress, uint8_t *Buffer,
                                            uint16_t Length)
{
  HAL_StatusTypeDef status = HAL_OK;

  status = HAL_I2C_Mem_Write(&hi2c3, Addr, (uint16_t)Reg,
                             MemAddress, Buffer, Length, 1000);

  /* Check the communication status */
  if(status != HAL_OK)
  {
    /* Re-Initiaize the I2C Bus */
    I2Cx_Error(Addr);
  }
  return status;
}

HAL_StatusTypeDef I2Cx_WriteMultiple_c(uint8_t Addr, uint16_t Reg,
                                            uint16_t MemAddress, uint8_t *Buffer,
                                            uint16_t Length) //borrame
{
  return I2Cx_WriteMultiple(Addr, Reg, MemAddress, *Buffer, Length);
}

/****************************************************************************
Function Name: . CAMERA_IO_Read2()
Description: . To read data from the I2C bus.
Parameters: . Addr : read address
            Reg  : register address
Dependencies: .
Assumptions: . .
Limitations: .
Exception: .
Handling: .
Return: status OK/FAIL
****************************************************************************/
uint8_t CAMERA_IO_Read_2(uint8_t Addr, uint16_t Reg, uint8_t *value)
{

  uint8_t read_value[33] = {0,};//FAIL
  uint8_t tmp = 1;//FAIL
  int i =0;
  for(i =0;i<3;i++)
  {
    if(I2Cx_ReadMultiple(Addr, Reg, I2C_MEMADD_SIZE_8BIT, (uint8_t*)&read_value, 32)==HAL_OK)
    {
      *value = read_value[0];
      tmp = 0;
      break;
    }
  }
  return tmp;
}

/****************************************************************************
Function Name: . CAMERA_IO_Write()
Description: . To write data to the I2C bus.
Parameters: .  Addr : write address
Reg  : register address
Value: Value to be written.
Dependencies: .
Assumptions: . .
Limitations: .
Exception: .
Handling: .
****************************************************************************/
void CAMERA_IO_Write(uint8_t Addr, uint16_t Reg, uint16_t Value)
{
  uint16_t tmp = Value;
  Value = ((uint16_t)(tmp) & 0xFF);
  I2Cx_WriteMultiple(Addr, Reg, I2C_MEMADD_SIZE_8BIT,(uint8_t*)&Value, 1);
  HAL_Delay(5);
}
/****************************************************************************
Function Name: . adv7180_Init()
Description: . Initializes the adv7180 CAMERA component.
Parameters: . DeviceAddr: Device address on communication Bus.
resolution: Camera resolution
Dependencies: .
Assumptions: . .
Limitations: .
Exception: .
Handling: .
****************************************************************************/
void adv7180_Init(uint16_t DeviceAddr)
{
  int status =1   ;
  int  ctl2;
  uint16_t lock_Counterz = 0;
  lock_Counter = CAMERA_IO_Read(DeviceAddr,   LOCK_COUNT);  
  status = CAMERA_IO_Read_2(DeviceAddr,   LOCK_COUNT, (uint8_t *)&lock_Counter);  
  if(status !=(-1))   /*validate firt message*/
  {
	  status = CAMERA_IO_Read_2(DeviceAddr,   0x11,(uint8_t *) &lock_Counterz);

    status = CAMERA_IO_Read_2(DeviceAddr,   STATUS1,(uint8_t *) &lock_Counter1);  
    status = CAMERA_IO_Read_2(DeviceAddr,   STATUS2,(uint8_t *)&lock_Counter2);
    status = CAMERA_IO_Read_2(DeviceAddr,   STATUS3,(uint8_t *)&lock_Counter3); 
    status = CAMERA_IO_Read_2(DeviceAddr,   ADI_CTL_2,(uint8_t *)&ctl2 ); 
    if((lock_Counter == 0xF6) && (lock_Counter1==0x0E)  && (lock_Counter3 == 0x78))
    {
      sDisconnected=1;
    }
  } 
  
}
/****************************************************************************
Function Name: . CAMERA_IO_Read()
Description: . To read data from the I2C bus.
Parameters: . Addr : read address
            Reg  : register address
Dependencies: .
Assumptions: . .
Limitations: .
Exception: .
Handling: .
Return: . read_value
****************************************************************************/
uint16_t CAMERA_IO_Read(uint8_t Addr, uint16_t Reg)
{
  uint16_t read_value = 0, tmp = 0;
  if(I2Cx_ReadMultiple(Addr, Reg, I2C_MEMADD_SIZE_8BIT, (uint8_t*)&read_value, 1)==HAL_OK)
  {

    tmp = ((uint16_t)(read_value)& 0xFF);
    read_value = tmp;
  }
  return read_value;
}

/****************************************************************************
Function Name: . adv7180_Config()
Description: .   Configures the adv7180 camera feature.
Parameters: .    DeviceAddr: Device address on I2C communication Bus.
                 feature: Camera feature to be configured
 value: Value to be configured
brightness_value: Brightness value to be configured
Dependencies: .
Assumptions: . .
Limitations: .
Exception: .
Handling: .
Note: . 5 combinations of the register configuration are present only one is enabled at once.
****************************************************************************/
void adv7180_Config(uint16_t DeviceAddr, 
                    uint32_t feature, 
                    uint32_t value, 
                    uint32_t brightness_value)
{  
#if AD_CVBS_IN_YPRPB_OUT
  config_write_one(DeviceAddr);
#elif NTSC_M_IN_FAST_SWITCHING
  config_write_two(DeviceAddr);
#elif PAL_M_IN_FAST_SWITCHING 
  config_write_three(DeviceAddr);
#elif YC_IN_YPRPB_OUT
  config_write_four(DeviceAddr);
#elif YPRPB_IN_YPRPB_OUT 
  config_write_five(DeviceAddr);
#endif
}

/****************************************************************************
Function Name: . config_write_one()
Description: . Writes config_write_one to the ADV7180 register configuration.
Parameters: .DeviceAddr: Device address on I2C communication Bus.
Dependencies: .
Assumptions: . .
Limitations: .
Exception: .
Handling: .
****************************************************************************/
volatile uint16_t adv_reg = 0;
void config_write_one(uint16_t DeviceAddr)
{

//#ifdef NEWBOARD
  CAMERA_IO_Write(DeviceAddr,   INPUT_CONTROL,        BYTE(0,0));   /* '04' select ain 3, autodetect composite standart*/
//#else
//  CAMERA_IO_Write(DeviceAddr,   INPUT_CONTROL,        BYTE(0,4));   /* '04' select ain 3, autodetect composite standart*/
//#endif
  CAMERA_IO_Write(DeviceAddr,   VIDEO_SELECTION,        BYTE(0xC,0xC));   /* '04' select ain 3, autodetect composite standart*/
  
  CAMERA_IO_Write(DeviceAddr,   VS_FIELD_CTL_1,       BYTE(1,2));   /* '12'  *******default*/
  CAMERA_IO_Write(DeviceAddr,   VS_FIELD_CTL_2,       BYTE(0xC,1)); /* 'C1' default*/
  CAMERA_IO_Write(DeviceAddr,   VS_FIELD_CTL_3,       BYTE(0xC,0)); /* 'C0' default*/
 // CAMERA_IO_Write(DeviceAddr,   NTSC_VBIT_BEGIN,      BYTE(2,0));   /* '20' 25 default*/
 // CAMERA_IO_Write(DeviceAddr,   NTSC_VBIT_END,        BYTE(0xC,0)); /* 04 default 41 */
//  CAMERA_IO_Write(DeviceAddr,   NTSC_VBIT_TOGGLE,     BYTE(0,0));   /* 63 default 84*/
//  CAMERA_IO_Write(DeviceAddr,   HS_POSITION_CTL_1,    BYTE(2,0));   /* '20'default 0x21*/  
//  CAMERA_IO_Write(DeviceAddr,   HS_POSITION_CTL_2,    BYTE(0,2));   /*default 0x00 */ //working0x02, 05 , 04, 0A */
//  CAMERA_IO_Write(DeviceAddr,   HS_POSITION_CTL_3,    BYTE(0,2));   /*default 0x00*/
  CAMERA_IO_Write(DeviceAddr,   POLARITY,             BYTE(0,1));   /*default*/
  CAMERA_IO_Write(DeviceAddr,   VS_FIELD_PIN_CTL,     BYTE(0,5));   /*default*/    //0 for field 0x01 for vsync
  CAMERA_IO_Write(DeviceAddr,   LOCK_COUNT,           BYTE(0xF,6)); /* 0xF6 default*/ 
  CAMERA_IO_Write(DeviceAddr,   MANDATE_ONE,           BYTE(8,0)); 
  CAMERA_IO_Write(DeviceAddr,   MANDATE_TWO,          BYTE(8,1)); 
  CAMERA_IO_Write(DeviceAddr,   MANDATE_ONE,           BYTE(0,0)); 
  CAMERA_IO_Write(DeviceAddr,   MANDATE_THREE,        BYTE(0,0xD)); 
  CAMERA_IO_Write(DeviceAddr,   EXT_OUTPUT_CONTROL,    BYTE(0,1));//Alex
  CAMERA_IO_Write(DeviceAddr,   DEFAULT_VALUE_C,      BYTE(0x0,0x0));//Alex

  CAMERA_IO_Write(DeviceAddr,   CONTRAST,              BYTE(0x8,0xF));//FO Default BYTE(0x8,0x0)
  CAMERA_IO_Write(DeviceAddr,   BRIGHTNESS,            BYTE(0x0,0x3));//FO Default BYTE(0x0,0x0)
  CAMERA_IO_Write(DeviceAddr,   HUE,                   BYTE(0x0,0x7));//FO Default BYTE(0x0,0x0)
  CAMERA_IO_Write(DeviceAddr,   SD_SATURATION_CB,      BYTE(0xF,0xF));//FO Default BYTE(0x8,0x0)
  CAMERA_IO_Write(DeviceAddr,   SD_SATURATION_CR,      BYTE(0xF,0xF));//FO Default BYTE(0x8,0x0)

  adv_reg = CAMERA_IO_Read(DeviceAddr,DEFAULT_VALUE_C);
//  CAMERA_IO_Write(DeviceAddr,   INPUT_CONTROL,        BYTE(0,4));   /* '04' select ain 3, autodetect composite standart*/
//  CAMERA_IO_Write(DeviceAddr,   VS_FIELD_CTL_1,       BYTE(1,2));   /* '12'  *******default*/
//  CAMERA_IO_Write(DeviceAddr,   VS_FIELD_CTL_2,       BYTE(0xC,1)); /* 'C1' default*/
//  CAMERA_IO_Write(DeviceAddr,   VS_FIELD_CTL_3,       BYTE(0xC,0)); /* 'C0' default*/
//  CAMERA_IO_Write(DeviceAddr,   NTSC_VBIT_BEGIN,      BYTE(2,0));   /* '20' 25 default*/
//  CAMERA_IO_Write(DeviceAddr,   NTSC_VBIT_END,        BYTE(0xC,0)); /* 04 default 41 */
//  CAMERA_IO_Write(DeviceAddr,   NTSC_VBIT_TOGGLE,     BYTE(0,0));   /* 63 default 84*/
//  CAMERA_IO_Write(DeviceAddr,   HS_POSITION_CTL_1,    BYTE(0,0));   /* '20'default 0x21*/  
//  CAMERA_IO_Write(DeviceAddr,   HS_POSITION_CTL_2,    BYTE(1,6));   /*default 0x00 */ //working0x02, 05 , 04, 0A */
//  CAMERA_IO_Write(DeviceAddr,   HS_POSITION_CTL_3,    BYTE(1,4));   /*default 0x00*/
//  CAMERA_IO_Write(DeviceAddr,   POLARITY,             BYTE(0,1));   /*default*/
//  CAMERA_IO_Write(DeviceAddr,   VS_FIELD_PIN_CTL,     BYTE(0,5));   /*default*/    //0 for field 0x01 for vsync
//  CAMERA_IO_Write(DeviceAddr,   LOCK_COUNT,           BYTE(0xF,6)); /* 0xF6 default*/ 
//  CAMERA_IO_Write(DeviceAddr,   MANDATE_ONE,           BYTE(8,0)); 
//  CAMERA_IO_Write(DeviceAddr,   MANDATE_TWO,          BYTE(8,1)); 
//  CAMERA_IO_Write(DeviceAddr,   MANDATE_ONE,           BYTE(0,0)); 
//  CAMERA_IO_Write(DeviceAddr,   MANDATE_THREE,        BYTE(0,0xD)); 
  
}

/****************************************************************************
Function Name: . config_write_two()
Description: . Writes config_write_two to the ADV7180 register configuration.
Parameters: . DeviceAddr: Device address on I2C communication Bus.
Dependencies: .
Assumptions: . .
Limitations: .
Exception: .
Handling: .
****************************************************************************/
void config_write_two(uint16_t ADV7180_I2C_ADDRESS)
{
  CAMERA_IO_Write(ADV7180_I2C_ADDRESS, POWER_MANAGEMENT,         BYTE(8,0));
  CAMERA_IO_Write(ADV7180_I2C_ADDRESS, POWER_MANAGEMENT,         BYTE(2,4));
  CAMERA_IO_Write(ADV7180_I2C_ADDRESS, CVBS_TRIM,                BYTE(0,0xD));
  CAMERA_IO_Write(ADV7180_I2C_ADDRESS, ANALOG_CLAMP_CONTROL,     BYTE(3,0));
  CAMERA_IO_Write(ADV7180_I2C_ADDRESS, INPUT_CONTROL,            BYTE(5,0));
  CAMERA_IO_Write(ADV7180_I2C_ADDRESS, VIDEO_SELECTION,          BYTE(8,0));
  CAMERA_IO_Write(ADV7180_I2C_ADDRESS, COMB_FILTER_CTL,          BYTE(0xB,1));
  CAMERA_IO_Write(ADV7180_I2C_ADDRESS, AGC_MODE_CTL,             BYTE(1,2));
  CAMERA_IO_Write(ADV7180_I2C_ADDRESS, VS_FIELD_PIN_CTL,         BYTE(0,2));
  CAMERA_IO_Write(ADV7180_I2C_ADDRESS, POLARITY,                 BYTE(8,1));
  CAMERA_IO_Write(ADV7180_I2C_ADDRESS, LOCK_COUNT,               BYTE(8,9));
  CAMERA_IO_Write(ADV7180_I2C_ADDRESS, ADC_CTL,                  BYTE(1,6));
  CAMERA_IO_Write(ADV7180_I2C_ADDRESS, MANUAL_WINDOW_CTL,        BYTE(0xA,2));
  CAMERA_IO_Write(ADV7180_I2C_ADDRESS, LOCK_COUNT,               BYTE(9,0xB));
  CAMERA_IO_Write(ADV7180_I2C_ADDRESS, ADC_SWITCH_1,             BYTE(8,5));
  CAMERA_IO_Write(ADV7180_I2C_ADDRESS, ADC_SWITCH_1,             BYTE(8,0));
  CAMERA_IO_Write(ADV7180_I2C_ADDRESS, ADC_SWITCH_1,             BYTE(0,0));
  CAMERA_IO_Write(ADV7180_I2C_ADDRESS, POWER_MANAGEMENT,         BYTE(0,0));
  CAMERA_IO_Write(ADV7180_I2C_ADDRESS, DEFAULT_VALUE_Y,          BYTE(3,6));
}

/****************************************************************************
Function Name: . config_write_three()
Description: . Writes config_write_three to the ADV7180 register configuration.
Parameters: .  DeviceAddr: Device address on I2C communication Bus.
Dependencies: .
Assumptions: . .
Limitations: .
Exception: .
Handling: .
****************************************************************************/
void config_write_three(uint16_t DeviceAddr)
{
  CAMERA_IO_Write(DeviceAddr, INPUT_CONTROL ,           BYTE(0,0)); //INSEL = CVBS in on AIn 1
  CAMERA_IO_Write(DeviceAddr, ANALOG_CLAMP_CONTROL,     BYTE(3,0)); //Reset Clamping Circuitry
  CAMERA_IO_Write(DeviceAddr, EXT_OUTPUT_CONTROL,       BYTE(5,7)); //Enable SFL
  CAMERA_IO_Write(DeviceAddr, SHAPING_FILTER_CTL_1,     BYTE(4,1)); //select SH1
  CAMERA_IO_Write(DeviceAddr, VS_FIELD_CTL_1,           BYTE(0,2)); //Clears NEWAV_MODE, SAV/EAV to suit ADV video encoders
  CAMERA_IO_Write(DeviceAddr, MANUAL_WINDOW_CTL,        BYTE(0xA,2)); //MWE Enable Manual Window, Colour Kill Threshold to 2
  CAMERA_IO_Write(DeviceAddr, INTERNAL_REG_ONE ,        BYTE(6,0xA)); //BLM optimisation
  CAMERA_IO_Write(DeviceAddr, INTERNAL_REG_TWO,         BYTE(0xA,0)); //BGB
  CAMERA_IO_Write(DeviceAddr, MANDATE_ONE,              BYTE(8,0)); //ADI Required Write
  CAMERA_IO_Write(DeviceAddr, MANDATE_TWO ,             BYTE(8,1)); //ADI Required Write
  CAMERA_IO_Write(DeviceAddr, ADI_CONTROL,              BYTE(0,0)); //ADI Required Write
  CAMERA_IO_Write(DeviceAddr, CVBS_TRIM,                BYTE(0,0xD)); //ADI Required
}

/****************************************************************************
Function Name: . config_write_four()
Description: . Writes config_write_four to the ADV7180 register configuration.
Parameters: . DeviceAddr: Device address on I2C communication Bus.
Dependencies: .
Assumptions: . .
Limitations: .
Exception: .
Handling: .
****************************************************************************/
void config_write_four(uint16_t DeviceAddr)
{
  CAMERA_IO_Write(DeviceAddr, ANALOG_CLAMP_CONTROL, BYTE(3,0)); //Reset Clamping Circuitry
  CAMERA_IO_Write(DeviceAddr, INPUT_CONTROL,        BYTE(0,6)); //Insel=YC, y=Ain1, C=Ain2
  CAMERA_IO_Write(DeviceAddr, EXT_OUTPUT_CONTROL,   BYTE(5,7)); //Enable SFL
  CAMERA_IO_Write(DeviceAddr, VS_FIELD_CTL_1,       BYTE(0,2)); //Clears NEWAV_MODE, SAV/EAV  to suit ADV video encoders
  CAMERA_IO_Write(DeviceAddr, MANUAL_WINDOW_CTL,    BYTE(0xA,2)); //MWE Enable Manual Window, Colour Kill Threshold to 2
  CAMERA_IO_Write(DeviceAddr, INTERNAL_REG_ONE,     BYTE(6,0xA)); //BLM optimisation
  CAMERA_IO_Write(DeviceAddr, INTERNAL_REG_TWO,     BYTE(0xA,0)); //BGB
  CAMERA_IO_Write(DeviceAddr, VS_FIELD_PIN_CTL,     BYTE(0,4)); //YC@2xOS
  CAMERA_IO_Write(DeviceAddr, MANDATE_ONE,          BYTE(2,0)); //ADI Required Write
  CAMERA_IO_Write(DeviceAddr, MANDATE_TWO,          BYTE(2,1)); //ADI Required Write
  CAMERA_IO_Write(DeviceAddr, ADI_CONTROL,          BYTE(0,0)); //ADI Required Write
}

/****************************************************************************
Function Name: . config_write_five()
Description: . Writes config_write_five to the ADV7180 register configuration.
Parameters: . DeviceAddr: Device address on I2C communication Bus.
Dependencies: .
Assumptions: . .
Limitations: .
Exception: .
Handling: .
****************************************************************************/
void config_write_five(uint16_t DeviceAddr)
{
  CAMERA_IO_Write(DeviceAddr, ANALOG_CLAMP_CONTROL,     BYTE(3,0)); //Reset Clamping Circuitry
  CAMERA_IO_Write(DeviceAddr, INPUT_CONTROL,            BYTE(0,9)); //INSEL = YPrPb, Y=Ain1, Pr=Ain2, Pb=Ain3
  CAMERA_IO_Write(DeviceAddr, VS_FIELD_CTL_1,           BYTE(0,2)); //Clears NEWAV_MODE, SAV/EAV  to suit ADV video encoders
  CAMERA_IO_Write(DeviceAddr, MANUAL_WINDOW_CTL,        BYTE(0xA,2)); //MWE Enable Manual Window
  CAMERA_IO_Write(DeviceAddr, INTERNAL_REG_ONE,         BYTE(6,0xA)); //BLM optimisation
  CAMERA_IO_Write(DeviceAddr, INTERNAL_REG_TWO,         BYTE(0xA,0)); //ADI Required Write
  CAMERA_IO_Write(DeviceAddr, VS_FIELD_PIN_CTL,         BYTE(0,4)); // ANI1 SELECTION AIN1 YC MODE MANDATORY WRITE (YC INPUTS ONLY)  
  CAMERA_IO_Write(DeviceAddr, MANDATE_ONE,              BYTE(2,0)); //ADI Required Write
  CAMERA_IO_Write(DeviceAddr, MANDATE_TWO,              BYTE(2,1)); //ADI Required Write
  CAMERA_IO_Write(DeviceAddr, MANDATE_ONE,              BYTE(0,0)); //ADI Required Write
}

/****************************************************************************
Function Name: . config_read_one()
Description: . Reads config_read_one of the ADV7180 register configuration.
Parameters: . DeviceAddr: Device address on I2C communication Bus.
Dependencies: .
Assumptions: . .
Limitations: .
Exception: .
Handling: .
****************************************************************************/
void config_read_one(uint16_t DeviceAddr)
{
//  CAMERA_IO_Read(DeviceAddr,   INPUT_CONTROL);  
//  CAMERA_IO_Read(DeviceAddr,   VS_FIELD_CTL_1 );  
//  CAMERA_IO_Read(DeviceAddr,   VS_FIELD_CTL_2 );  
//  CAMERA_IO_Read(DeviceAddr,   VS_FIELD_CTL_3  );  
//  CAMERA_IO_Read(DeviceAddr,   NTSC_VBIT_BEGIN  );  
//  CAMERA_IO_Read(DeviceAddr,   NTSC_VBIT_END    );  
//  CAMERA_IO_Read(DeviceAddr,   NTSC_VBIT_TOGGLE );  
//  CAMERA_IO_Read(DeviceAddr,   HS_POSITION_CTL_1);  
//  CAMERA_IO_Read(DeviceAddr,   HS_POSITION_CTL_2);  
//  CAMERA_IO_Read(DeviceAddr,   HS_POSITION_CTL_3);  
//  CAMERA_IO_Read(DeviceAddr,   POLARITY         );  
//  CAMERA_IO_Read(DeviceAddr,   VS_FIELD_PIN_CTL );  
//    lock_Counter = CAMERA_IO_Read(DeviceAddr,   LOCK_COUNT);  
//  CAMERA_IO_Read(DeviceAddr,   MANDATE_ONE      );  
//  CAMERA_IO_Read(DeviceAddr,   MANDATE_TWO      );  
//  CAMERA_IO_Read(DeviceAddr,   MANDATE_ONE      );  
//  CAMERA_IO_Read(DeviceAddr,   MANDATE_THREE    );  


  lock_Counter = CAMERA_IO_Read(DeviceAddr,   LOCK_COUNT);  
  lock_Counter1 = CAMERA_IO_Read(DeviceAddr,   STATUS1);  
  lock_Counter2 = CAMERA_IO_Read(DeviceAddr,   STATUS2);  
  lock_Counter3 = CAMERA_IO_Read(DeviceAddr,   STATUS3); 
  lock_Counter3 = CAMERA_IO_Read(DeviceAddr,   ADI_CTL_2); 
   
}

/****************************************************************************
Function Name: . config_read_two()
Description: . Reads config_read_one of the ADV7180 register configuration.
Parameters: . DeviceAddr: Device address on I2C communication Bus.
Dependencies: .
Assumptions: . .
Limitations: .
Exception: .
Handling: .
****************************************************************************/
void config_read_two(uint16_t DeviceAddr)
{
  CAMERA_IO_Read(DeviceAddr, POWER_MANAGEMENT     );
  CAMERA_IO_Read(DeviceAddr, POWER_MANAGEMENT     );
  CAMERA_IO_Read(DeviceAddr, CVBS_TRIM            );
  CAMERA_IO_Read(DeviceAddr, ANALOG_CLAMP_CONTROL );
  CAMERA_IO_Read(DeviceAddr, INPUT_CONTROL        );
  CAMERA_IO_Read(DeviceAddr, VIDEO_SELECTION      );
  CAMERA_IO_Read(DeviceAddr, COMB_FILTER_CTL      );
  CAMERA_IO_Read(DeviceAddr, AGC_MODE_CTL         );
  CAMERA_IO_Read(DeviceAddr, VS_FIELD_PIN_CTL     );
  CAMERA_IO_Read(DeviceAddr, POLARITY             );
  CAMERA_IO_Read(DeviceAddr, LOCK_COUNT           );
  CAMERA_IO_Read(DeviceAddr, ADC_CTL              );
  CAMERA_IO_Read(DeviceAddr, MANUAL_WINDOW_CTL    );
  CAMERA_IO_Read(DeviceAddr, LOCK_COUNT           );
  CAMERA_IO_Read(DeviceAddr, ADC_SWITCH_1         );
  CAMERA_IO_Read(DeviceAddr, ADC_SWITCH_1         );
  CAMERA_IO_Read(DeviceAddr, ADC_SWITCH_1         );
  CAMERA_IO_Read(DeviceAddr, POWER_MANAGEMENT     );
  CAMERA_IO_Read(DeviceAddr, DEFAULT_VALUE_Y      );
}

/****************************************************************************
Function Name: . config_read_three()
Description: . Reads config_read_one of the ADV7180 register configuration.
Parameters: . DeviceAddr: Device address on I2C communication Bus.
Dependencies: .
Assumptions: . .
Limitations: .
Exception: .
Handling: .
****************************************************************************/
void config_read_three(uint16_t DeviceAddr)
{
  CAMERA_IO_Read(DeviceAddr, INPUT_CONTROL       );
  CAMERA_IO_Read(DeviceAddr, ANALOG_CLAMP_CONTROL);
  CAMERA_IO_Read(DeviceAddr, EXT_OUTPUT_CONTROL  );
  CAMERA_IO_Read(DeviceAddr, SHAPING_FILTER_CTL_1);
  CAMERA_IO_Read(DeviceAddr, VS_FIELD_CTL_1      );
  CAMERA_IO_Read(DeviceAddr, MANUAL_WINDOW_CTL   );
  CAMERA_IO_Read(DeviceAddr, INTERNAL_REG_ONE    );
  CAMERA_IO_Read(DeviceAddr, INTERNAL_REG_TWO    );
  CAMERA_IO_Read(DeviceAddr, MANDATE_ONE         );
  CAMERA_IO_Read(DeviceAddr, MANDATE_TWO         );
  CAMERA_IO_Read(DeviceAddr, ADI_CONTROL         );
  CAMERA_IO_Read(DeviceAddr, CVBS_TRIM           );
}

/****************************************************************************
Function Name: . config_read_four()
Description: . Reads config_read_one of the ADV7180 register configuration.
Parameters: . DeviceAddr: Device address on I2C communication Bus.
Dependencies: .
Assumptions: . .
Limitations: .
Exception: .
Handling: .
****************************************************************************/
void config_read_four(uint16_t DeviceAddr)
{
  CAMERA_IO_Read(DeviceAddr, ANALOG_CLAMP_CONTROL );
  CAMERA_IO_Read(DeviceAddr, INPUT_CONTROL        );
  CAMERA_IO_Read(DeviceAddr, EXT_OUTPUT_CONTROL   );
  CAMERA_IO_Read(DeviceAddr, VS_FIELD_CTL_1       );
  CAMERA_IO_Read(DeviceAddr, MANUAL_WINDOW_CTL    );
  CAMERA_IO_Read(DeviceAddr, INTERNAL_REG_ONE     );
  CAMERA_IO_Read(DeviceAddr, INTERNAL_REG_TWO     );
  CAMERA_IO_Read(DeviceAddr, VS_FIELD_PIN_CTL     );
  CAMERA_IO_Read(DeviceAddr, MANDATE_ONE          );
  CAMERA_IO_Read(DeviceAddr, MANDATE_TWO          );
  CAMERA_IO_Read(DeviceAddr, ADI_CONTROL          );    
}

/****************************************************************************
Function Name: . config_read_five()
Description: . Reads config_read_one of the ADV7180 register configuration.
Parameters: . DeviceAddr: Device address on I2C communication Bus.
Dependencies: .
Assumptions: . .
Limitations: .
Exception: .
Handling: .
****************************************************************************/
void config_read_five(uint16_t DeviceAddr)
{
  CAMERA_IO_Read(DeviceAddr, ANALOG_CLAMP_CONTROL);
  CAMERA_IO_Read(DeviceAddr, INPUT_CONTROL       );
  CAMERA_IO_Read(DeviceAddr, VS_FIELD_CTL_1      );
  CAMERA_IO_Read(DeviceAddr, MANUAL_WINDOW_CTL   );
  CAMERA_IO_Read(DeviceAddr, INTERNAL_REG_ONE    );
  CAMERA_IO_Read(DeviceAddr, INTERNAL_REG_TWO    );
  CAMERA_IO_Read(DeviceAddr, VS_FIELD_PIN_CTL    );
  CAMERA_IO_Read(DeviceAddr, MANDATE_ONE         );
  CAMERA_IO_Read(DeviceAddr, MANDATE_TWO         );
  CAMERA_IO_Read(DeviceAddr, MANDATE_ONE         );
}

/****************************************************************************
Function Name: . adv7180_ReadID()
Description: . Initializes the I2C and reads the configuration from 
               the adv7180 for the selected
configuration.
Parameters: .
Dependencies: .
Assumptions: . .
Limitations: .
Exception: .
Handling: .
****************************************************************************/
uint16_t adv7180_ReadID(uint16_t DeviceAddr)
{
  /* Initialize I2C */
  CAMERA_IO_Init();
  
#if AD_CVBS_IN_YPRPB_OUT
  config_read_one(DeviceAddr);
  return 1;
#elif NTSC_M_IN_FAST_SWITCHING
  config_read_two(DeviceAddr);
  return 2;
#elif PAL_M_IN_FAST_SWITCHING 
  config_read_three(DeviceAddr);
  return 3;
#elif YC_IN_YPRPB_OUT
  config_read_four(DeviceAddr);
  return 4;
#elif YPRPB_IN_YPRPB_OUT 
  config_read_five(DeviceAddr);
  return 5;
#endif
  //return 0;
}

/**************** (C) COPYRIGHT 2012 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
