﻿/*
* j1939_cam11_cam21.h - contains defines for cam11/cam21 extension
*
* Copyright (c) 2021 emotas embedded communication GmbH
*
*-------------------------------------------------------------------
* $Id: j1939_cam11_cam21.h 38182 2021-10-04 14:25:29Z boe $
*-------------------------------------------------------------------
*
*
*
*/

/**
* \brief data types
*
* \file j1939_cam11_cam21.h - contains defines for cam11_21c
*
*/

#ifndef J1939_CAM11_CAM21_H
#define J1939_CAM11_CAM21_H 1


/** \brief function pointer to CAM11/CAM21 server event
 * \param execute - execute or test only
 * \param channel - sdo number
 * \param index - object index
 * \param subindex - object subindex
 * 
 * \return RET_T
 */
typedef RET_T (* CO_EVENT_CAM11_CAM21_SERVER_T)(CO_LINE_TYPE, BOOL_T, UNSIGNED8, UNSIGNED16, UNSIGNED8); /*lint !e960 customer specific parameter names */


/** \brief function pointer to CAM11/CAM21 client read event
 * \param channel - channel number
 * \param index - object index
 * \param subindex - object subindex
 * \param size - size of received data
 * \param result - result of transfer
 * 
 */
typedef void (* CO_EVENT_CAM11_CAM21_CLIENT_READ_T)(CO_LINE_TYPE, UNSIGNED8, UNSIGNED16, UNSIGNED8, UNSIGNED32, UNSIGNED32); /*lint !e960 customer specific parameter names */


/** \brief function pointer to CAM11/CAM21 client write event
 * \param channel - sdo number
 * \param index - object index
 * \param subindex - object subindex
 * \param result - result of transfer
 * 
 */
typedef void (* CO_EVENT_CAM11_CAM21_CLIENT_WRITE_T)(CO_LINE_TYPE, UNSIGNED8, UNSIGNED16, UNSIGNED8, UNSIGNED32); /*lint !e960 customer specific parameter names */



EXTERN_DECL RET_T j1939OdInit(CO_LINE_DECL);
EXTERN_DECL RET_T j1939_cam21Read(CO_LINE_DECL, UNSIGNED8 dstNode,
			UNSIGNED8 sdoClientNr, UNSIGNED16 index, UNSIGNED8 subIndex,
			UNSIGNED8 *pData, UNSIGNED32 dataSize, UNSIGNED8 numeric,
			UNSIGNED32 timeout);
EXTERN_DECL RET_T j1939_cam21Write(CO_LINE_DECL, UNSIGNED8 dstNode,
			UNSIGNED8 sdoClientNr, UNSIGNED16 index, UNSIGNED8 subIndex,
			UNSIGNED8 *pData, UNSIGNED32 dataSize, UNSIGNED8 numeric,
			UNSIGNED32 timeout);

EXTERN_DECL RET_T	j1939EventRegister_CAM11_CAM21_CLIENT_READ(CO_EVENT_CAM11_CAM21_CLIENT_READ_T pFunction);
EXTERN_DECL RET_T	j1939EventRegister_CAM11_CAM21_CLIENT_WRITE(CO_EVENT_CAM11_CAM21_CLIENT_WRITE_T pFunction);

EXTERN_DECL RET_T	j1939EventRegister_CAM11_CAM21_SERVER_READ(CO_EVENT_CAM11_CAM21_SERVER_T pFunction);
EXTERN_DECL RET_T	j1939EventRegister_CAM11_CAM21_SERVER_WRITE(CO_EVENT_CAM11_CAM21_SERVER_T pFunction);


#endif /* J1939_CAM11_CAM21_H */

