/*
* j1939_nmea2000.h - contains defines for diagnostic
*
* Copyright (c) 2020-2020 emotas embedded communication GmbH
*
*-------------------------------------------------------------------
* $Id: $
*-------------------------------------------------------------------
*
*
*
*/

/**
* \brief data types
*
* \file j1939_nmea2000.h - contains defines for NMEA2000
*
*/

#ifndef J1939_NMEA2000_H
#define J1939_NMEA2000_H 1


/* datatypes */
#define REQ_GRP_FCT_CODE_REQ	0u	/**< group function request */
#define REQ_GRP_FCT_CODE_CMD	1u	/**< group function command */
#define REQ_GRP_FCT_CODE_ACQ	2u	/**< group function acknowledge */



RET_T j1939_nmeaGroupReq(CO_LINE_DECL, UNSIGNED32 reqPgn,
			UNSIGNED32 transInterval, UNSIGNED16 transIntervalOffset);
RET_T j1939_nmeaGroupCmd(CO_LINE_DECL, UNSIGNED32 cmdPgn, UNSIGNED8	priority);
RET_T j1939_nmeaGroupAcq(CO_LINE_DECL, UNSIGNED32 acqPgn,
			UNSIGNED8 pgnErrorCode, UNSIGNED8 priorityErrorCode);
RET_T j1939_nmeaGroupPgnPair(CO_LINE_DECL, UNSIGNED8 fieldNumber,
			UNSIGNED32 value, UNSIGNED8	valueLen);
RET_T j1939_nmeaGroupTransmit(CO_LINE_DECL, UNSIGNED8 dstAddress);

#endif /* J1939_NMEA2000_H */

