/*
* ij1939_address.h - contains internal defines
*
* Copyright (c) 2014-2019 emotas embedded communication GmbH
*
*-------------------------------------------------------------------
* $Id: ij1939_cmdt.h 38573 2021-10-15 08:39:19Z boe $
*
*-------------------------------------------------------------------
*
*
*
*/

/**
* \file
* \brief dataty type header
*/

#ifndef IJ1939_CMDT_H
#define IJ1939_CMDT_H 1

/* datatypes */

/** \brief function pointer to CMDT mapping function
 *
 * This function is called to map next data into buffer for special mapping
 *
 * \param actual
 *		seqNumber		actual sequence number
 *		buf				pointer to CAN buf (max. 7 bytes)
 *
 * \return
 *              void
 */
typedef void (* J1939_CMDT_MAPPING_FCT_T)(CO_LINE_DECL, UNSIGNED32 seqNr, UNSIGNED8 *pbuf);


/* function prototypes */

RET_T	ij1939_cmdtInit(CO_LINE_DECL);
RET_T	ij1939_cmdtUpdateCob(CO_LINE_DECL, UNSIGNED8 nodeAddress);
void	ij1939_cmdtConnectReceived(CO_LINE_DECL, const CO_CAN_REC_MSG_T *pMsg);
void	ij1939_cmdtConnectAnswerReceived(CO_LINE_DECL, const CO_CAN_REC_MSG_T *pMsg);
void	ij1939_cmdtDataReceived(CO_LINE_DECL, const CO_CAN_REC_MSG_T *pMsg);
RET_T	ij1939_cmdtTrStart(CO_LINE_DECL, const J1939_PGN_CONFIG_T *pCfg,
			UNSIGNED8 node, UNSIGNED16 length, J1939_CMDT_MAPPING_FCT_T fct);

#endif /* IJ1939_CMDT_H */

