#ifndef SCR_CAMERAPRESENTER_HPP
#define SCR_CAMERAPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class SCR_CAMERAView;

class SCR_CAMERAPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    SCR_CAMERAPresenter(SCR_CAMERAView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~SCR_CAMERAPresenter() {};
    virtual void keyUpdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);

    virtual void trigger();
private:
    SCR_CAMERAPresenter();

    SCR_CAMERAView& view;
};

#endif // SCR_CAMERAPRESENTER_HPP
