#ifndef SCR_IOPRESENTER_HPP
#define SCR_IOPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class SCR_IOView;

class SCR_IOPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    SCR_IOPresenter(SCR_IOView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~SCR_IOPresenter() {};
    virtual void keyUpdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);

    virtual void trigger();
private:
    SCR_IOPresenter();

    SCR_IOView& view;
};

#endif // SCR_IOPRESENTER_HPP
