#ifndef SCR_MAINPRESENTER_HPP
#define SCR_MAINPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class SCR_MAINView;

class SCR_MAINPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    SCR_MAINPresenter(SCR_MAINView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~SCR_MAINPresenter() {};
    virtual void keyUpdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);
    virtual void handleTickEvent();
    virtual void trigger();
private:
    SCR_MAINPresenter();

    SCR_MAINView& view;

};

#endif // SCR_MAINPRESENTER_HPP
