#ifndef SCR_MAINVIEW_HPP
#define SCR_MAINVIEW_HPP

#include <gui_generated/scr_main_screen/SCR_MAINViewBase.hpp>
#include <gui/scr_main_screen/SCR_MAINPresenter.hpp>

class SCR_MAINView : public SCR_MAINViewBase
{
public:
    SCR_MAINView();
    virtual ~SCR_MAINView() {}
    virtual void setupScreen();
    virtual void tearDownScreen();
    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void handleTickEvent();
    void updateProgress(uint16_t tick);
    virtual void watchdogstatus(uint8_t *val);

        void moveNext();
        void movePrevious();
        void moveNextScreen();
        void moveBackScreen();
protected:
        bool increase = true;
        uint32_t key_position;
        uint8_t rtc_refresh_val;
        int tickCounter;
        int digitalHours;
        int digitalMinutes;
        int digitalSeconds;
        uint8_t state;
        uint8_t mode;
        uint8_t refresh_val;
        uint8_t values;
        int value;
        uint32_t val;
        int imageProgress1Max;
        int imageProgress1Min;

        int circleProgress1Max;
        int circleProgress1Min;

        int gauge1Max;
        int gauge1Min;

        uint8_t brightness_value;
        uint8_t voltage_mode;
};

#endif // SCR_MAINVIEW_HPP
