#ifndef SCR_TIMERPRESENTER_HPP
#define SCR_TIMERPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class SCR_TIMERView;

class SCR_TIMERPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    SCR_TIMERPresenter(SCR_TIMERView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~SCR_TIMERPresenter() {};
    virtual void keyUpdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);

    virtual void trigger();
private:
    SCR_TIMERPresenter();

    SCR_TIMERView& view;
};

#endif // SCR_TIMERPRESENTER_HPP
