#include <gui/scr_camera_screen/SCR_CAMERAView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"
#include <BitmapdataBase.hpp>

uint8_t mode;
uint8_t cam_can_state;
uint8_t stream_state;

SCR_CAMERAView::SCR_CAMERAView()
{
	streaming_mode = 0;
	key_position = 0;
	vf = 0;
	hf = 0;
#if (SDK_SERVICE_CAMERA == PS_ENABLE)
	Get_DL(CAMERA_VIDEO_FLIP_VERTICAL, &vf);
	TBTvf(vf);
	Get_DL(CAMERA_VIDEO_FLIP_HORIZONTAL, &hf);
	TBThf(hf);
#endif
}

void SCR_CAMERAView::setupScreen()
{
    SCR_CAMERAViewBase::setupScreen();
}

void SCR_CAMERAView::tearDownScreen()
{
    SCR_CAMERAViewBase::tearDownScreen();
}

void SCR_CAMERAView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext(val);
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		moveNextScreen(val);
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();

}

void SCR_CAMERAView::movePrevious()
{
	application().gotoSCR_WLIGHTSScreenNoTransition();
#if (SDK_SERVICE_CAMERA == PS_ENABLE)
	mode = CAMERA_STREAM_OFF;
	/* Call the DB Variable to set the Full screen Mode */
	Set_DL(CAMERA_VIDEO_STREAM, &mode);
	mode = FULL_SCREEN_ON;
	streaming_mode = 0;
#endif
}

void SCR_CAMERAView::TBTvf(uint8_t bOn)
{
	if (bOn)
	{
		TBT_FlipVer.setBitmaps(touchgfx::Bitmap(BITMAP_BLUE_TOGGLEBARS_TOGGLE_RE_SMALL_BUTTON_ON_ID), touchgfx::Bitmap(BITMAP_BLUE_TOGGLEBARS_TOGGLE_RE_SMALL_BUTTON_ON_ID));
		TBT_FlipVer.invalidate();
	} else
	{
		TBT_FlipVer.setBitmaps(touchgfx::Bitmap(BITMAP_BLUE_TOGGLEBARS_TOGGLE_RE_SMALL_BUTTON_OFF_ID), touchgfx::Bitmap(BITMAP_BLUE_TOGGLEBARS_TOGGLE_RE_SMALL_BUTTON_OFF_ID));
		TBT_FlipVer.invalidate();
	}
}
void SCR_CAMERAView::TBThf(uint8_t bOn)
{
if (bOn)
    {
    	TBT_FlipHor.setBitmaps(touchgfx::Bitmap(BITMAP_BLUE_TOGGLEBARS_TOGGLE_RE_SMALL_BUTTON_ON_ID), touchgfx::Bitmap(BITMAP_BLUE_TOGGLEBARS_TOGGLE_RE_SMALL_BUTTON_ON_ID));
    	TBT_FlipHor.invalidate();
    } else
    {
    	TBT_FlipHor.setBitmaps(touchgfx::Bitmap(BITMAP_BLUE_TOGGLEBARS_TOGGLE_RE_SMALL_BUTTON_OFF_ID), touchgfx::Bitmap(BITMAP_BLUE_TOGGLEBARS_TOGGLE_RE_SMALL_BUTTON_OFF_ID));
    	TBT_FlipHor.invalidate();
    }
}
void SCR_CAMERAView::moveNext(uint8_t val)
{
	{

		if (val==KEY2_SHORT_PRESS)
		{

			switch(key_position)
					{
			case 1:
				if (vf) vf=0; else vf=1;
				TBTvf(vf);
#if (SDK_SERVICE_CAMERA == PS_ENABLE)
				Set_DL(CAMERA_VIDEO_FLIP_VERTICAL, &vf);
#endif
				break;
			case 2:
				if (hf) hf=0; else hf=1;
				TBThf(hf);
#if (SDK_SERVICE_CAMERA == PS_ENABLE)
				Set_DL(CAMERA_VIDEO_FLIP_HORIZONTAL, &hf);
#endif
				break;
					}
			return;
		}

		key_position++;

		if (3 == key_position)
			key_position = 1;

		switch(key_position)
		{
			case 1:
				/* DESelect the Keypad button */
				FLPHR.setLabelColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
				FLPHR.invalidate();

				/* Select the Keypad button */
				FLPVT.setLabelColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				FLPVT.invalidate();
				break;

			case 2:
				/* DESelect the Keypad button */
				FLPVT.setLabelColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
				FLPVT.invalidate();

				/* Select the Keypad button */
				FLPHR.setLabelColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				FLPHR.invalidate();
				break;
			default:
				break;
		}
	}
	this->invalidate();
}
void SCR_CAMERAView::moveNextScreen(uint8_t val)
{
	if (0 == streaming_mode)
	{

#if (SDK_SERVICE_CAMERA == PS_ENABLE)

		Set_DL(CAMERA_VIDEO_FLIP_VERTICAL, &vf);
		Set_DL(CAMERA_VIDEO_FLIP_HORIZONTAL, &hf);

		/* Call the DB Variable to set the Full screen Mode */
		Set_DL(CAMERA_VIDEO_MODE, &mode);

		mode = CAMERA_STREAM_ON;

		/* Call the DB Variable to set the Full screen Mode */
		Set_DL(CAMERA_VIDEO_STREAM, &mode);
		streaming_mode = 1;
#endif

	}
	else
	{

#if (SDK_SERVICE_CAMERA == PS_ENABLE)
		mode = CAMERA_STREAM_OFF;

		/* Call the DB Variable to set the Full screen Mode */
		Set_DL(CAMERA_VIDEO_STREAM, &mode);
		mode = FULL_SCREEN_ON;
		streaming_mode = 0;
#endif
	}
	this->invalidate();

}

void SCR_CAMERAView::moveBackScreen()
{
#if (SDK_SERVICE_CAMERA == PS_ENABLE)
	mode = CAMERA_STREAM_OFF;
	/* Call the DB Variable to set the Full screen Mode */
	Set_DL(CAMERA_VIDEO_STREAM, &mode);
	mode = FULL_SCREEN_ON;
#endif
	streaming_mode = 0;
    this->invalidate();
	application().gotoSCR_TIMERScreenNoTransition();
}

void SCR_CAMERAView::trigger()
{

#if(SDK_CAMERA_STOP_CAN == PS_ENABLE)
	uint8_t cam_state = 0;

	Get_DL(TRANSMISSION_CURRENT_GEAR, &cam_state);
	if((cam_state == 1) && (stream_state != 1))
	{
		stream_state = 1;

		mode = FULL_SCREEN_ON;


#if (SDK_SERVICE_CAMERA == PS_ENABLE)
		/* Call the DB Variable to set the Full screen Mode */
		Set_DL(CAMERA_VIDEO_MODE, &mode);

		mode = CAMERA_STREAM_ON;

		/* Call the DB Variable to set the Full screen Mode */
		Set_DL(CAMERA_VIDEO_STREAM, &mode);

		this->invalidate();
#endif
	}
	else
	if((cam_state == 0) && (stream_state != 2))
	{
		vf = 0;
		hf = 0;

		Set_DL(CAMERA_VIDEO_FLIP_VERTICAL, &vf);
		Set_DL(CAMERA_VIDEO_FLIP_HORIZONTAL, &hf);
		stream_state = 2;

		mode = CAMERA_STREAM_OFF;
		/* Call the DB Variable to set the Full screen Mode */
		Set_DL(CAMERA_VIDEO_STREAM, &mode);

		this->invalidate();
	}
#endif
}

void SCR_CAMERAView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
