#include <gui/scr_timer_screen/SCR_TIMERView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

uint32_t swtimeout_val;

SCR_TIMERView::SCR_TIMERView()
{
	state = 1;
	shot = 1;
	key_position = 1;
	INCTIME.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	INCTIME.invalidate();

	timeout = 0;
	Get_DL(START_EEPROM + (EE_CAL01),(uint8_t *)&timeout);

	Unicode::snprintf(textArea8Buffer, TEXTAREA8_SIZE, "%d", timeout);
	textArea8.invalidate();

	timeout = 0;
}

void SCR_TIMERView::setupScreen()
{
    SCR_TIMERViewBase::setupScreen();
}

void SCR_TIMERView::tearDownScreen()
{
    SCR_TIMERViewBase::tearDownScreen();
}

void SCR_TIMERView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if(KEY2_SHORT_PRESS == val)
	{
#if (SDK_SERVICE_SWTIMER == PS_ENABLE)
		if ((timeout < 65535) && (timeout >= 0))
		{
			timeout ++;
			sw_timeout = (timeout * 50);
			Unicode::snprintf(VLT1Buffer, VLT1_SIZE, " %d" , sw_timeout);
		}
		else
		{
			Unicode::snprintf(VLT1Buffer, VLT1_SIZE, "Max-%d" , timeout);
		}

		/* Set the Timer Timeout_1 */
		SET_DB(TIMER_TIMEOUT_01, (uint8_t *)&sw_timeout);

		VLT1.invalidate();
#endif
	}
	else
	if(KEY2_LONG_PRESS == val)
	{
		{
			key_position++;
			if (4 == key_position)
				key_position = 1;

			switch(key_position)
			{
				case 1:
					/* DESelect the Keypad button */
					SLEEP.setLabelColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
					SLEEP.invalidate();

					/* Select the Keypad button */
					INCTIME.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
					INCTIME.invalidate();
					break;

				case 2:
					/* DESelect the Keypad button */
					INCTIME.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
					INCTIME.invalidate();

					/* Select the Keypad button */
					DCRTIME.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
					DCRTIME.invalidate();
					break;

				case 3:
					/* DESelect the Keypad button */
					DCRTIME.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
					DCRTIME.invalidate();

					/* Select the Keypad button */
					SLEEP.setLabelColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
					SLEEP.invalidate();
					break;

				default:
					break;
			}
		}
	}
	else
	if(KEY3_SHORT_PRESS == val)
	{
#if (SDK_SERVICE_SWTIMER == PS_ENABLE)
		if ((timeout > 0) && (timeout <= 65535))
		{
			timeout --;
			sw_timeout = (timeout * 50);
			Unicode::snprintf(VLT1Buffer, VLT1_SIZE, " %d" , sw_timeout);
		}
		else
		{
			Unicode::snprintf(VLT1Buffer, VLT1_SIZE, "Min-%d" , timeout);
		}

		/* Set the Timer Timeout_1 */
		SET_DB(TIMER_TIMEOUT_01, (uint8_t *)&sw_timeout);

		VLT1.invalidate();
#endif
	}
	else
	if(KEY3_LONG_PRESS == val)
	{
#if (SDK_SERVICE_SWTIMER == PS_ENABLE)
		switch(key_position)
		{
			case 1:
				SET_DB(TIMER_MODE_01, (uint8_t *)&shot);
				SET_DB(TIMER_STATUS_01, (uint8_t *)&state);
				break;

			case 2:
				SET_DB(TIMER_MODE_01, (uint8_t *)&shot);
				SET_DB(TIMER_STATUS_01, (uint8_t *)&state);
				break;

			case 3:
				pm_state = PM_STOP_MODE;
				Set_DL(POWER_MODE, &pm_state);
				break;

			default:
				break;
		}
#endif
	}
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();
}

void SCR_TIMERView::movePrevious()
{
	application().gotoSCR_CAMERAScreenNoTransition();
}

void SCR_TIMERView::moveBackScreen()
{

}

void SCR_TIMERView::trigger()
{
#if (SDK_SERVICE_SWTIMER == PS_ENABLE)
	uint8_t timer1_state = 0;

	Get_DL(TIMER_CALLBACK_01, &timer1_state);

	if(CALLBACK_OCCURED == timer1_state)
	{
		/* Update the timeout value to EEPROM */
		Set_DL(START_EEPROM + (EE_CAL01),(uint8_t *)&swtimeout_val);

		Unicode::snprintf(textArea8Buffer, TEXTAREA8_SIZE, "%d", swtimeout_val);
		textArea8.invalidate();

		swtimeout_val++;
	}
#endif

}

void SCR_TIMERView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
